{library_calls/log_hlp.i}
{library_calls/libname.i}

/* stdcall uses callee cleaning of the stack, so it is very sensitive to any case */
/* of mismatched argument sizes; when the 4GL trys using args that are not the same */
/* length as is expected by the functions called, the stack pointer will end up */
/* pointing to the wrong index (after the proper location when the passed args are */
/* larger than expected and before the proper location when the passed args are */
/* smaller than expected; the 4GL code that does the dispatching/calling can become */
/* unstable in this case, causing the process to abend; for this reason, we bypass */
/* such cases; this ONLY HAPPENS for INPUT parms because the other parm types use */
/* pointers (INPUT-OUTPUT or OUTPUT) or use registers for returning data and thus */
/* cannot destabilize the process */
if "{&callconv}" eq "stdcall" then
do:
   if index("{&apiname}", "{&apitype}") eq 0 then
   do:
      bypass = true.
      run log-it (input "{&apiname} reading {&apitype} into decimal BYPASSED").
   end.
end.

if not bypass then
do:
   run log-it (input "{&apiname} reading {&apitype} into decimal start").
   
   if (sz * 2) ne extent(dnum_array) then run log-err (input "Hard coded extent size " + string(extent(dnum_array)) + " should be set to " + string(sz * 2) + "!").
   
   do i = 1 to sz:
   
      /* pass a value (from the reversed array of decimals copied out of the DLL) */
      dnum = d-input[i].
   
      err-flag = true.
      inner:
      do on error undo, leave inner:
         run {&apiname} (input dnum).
         err-flag = false.
      end.
      if err-flag then
         run log-err (input "Failure occured in {&apiname}() - {&apitype} into decimal for entry: " + string(i) + ".").
   end.
   
   run {&apiname}_array (input dnum_array).
   
   procedure {&apiname} external "{&libname}" {&callconv}:
      define input parameter d as {&apitype}.
   end.
   
   procedure {&apiname}_array external "{&libname}" {&callconv}:
      define input parameter d as {&apitype}.
   end.
   
   run log-it (input "{&apiname} reading {&apitype} into decimal end").
end.
