{library_calls/log_hlp.i}

run log-it (input "input_parameter start").

def var sz as integer.
def var dsz as integer.
def var i as int.
def var ivalues as memptr.
def var namebuf as memptr.
def var ptrs as memptr.
def var ilist as int64 extent.
def var pointer-size as int.

set-size(namebuf) = 256.

set-size(ptrs) = 128.
set-byte-order(ptrs) = little-endian.
 
run ivalues_size (output sz).
run dvalues_size (output dsz).

/* copy the full list into an array */
extent(ilist) = sz.
set-size(ivalues) = sz * 8.
run copy_ivalues (input-output ivalues).
do i = 1 to sz:
   ilist[i] = get-int64(ivalues, ((i - 1) * 8) + 1).
end.
set-size(ivalues) = 0.

/* initialize floating point array */
run init_dvalues.

/* run our tests */

/* on platforms other than windows, the cdecl tests actually just tests the */
/* default calling convention for the platform (the 4GL ignores any calling */
/* convention specification unless on Windows) */

run library_calls/input/input_parameter_integer_cdecl.p (input sz, input ilist).
run library_calls/input/input_parameter_int64_cdecl.p (input sz, input ilist).
run library_calls/input/input_integral_api_type_input_overflow_errors.p.
run library_calls/input/input_parameter_decimal_cdecl.p (input dsz).
run library_calls/input/input_int_parameter_into_double_is_nop.p.
run library_calls/input/input_double_parameter_into_int64_is_junk.p.
run library_calls/input/input_parameter_char_ptr_into_memptr_cdecl.p.
run library_calls/input/input_parameter_char_actually_works.p.
run library_calls/input/input_parameter_void_ptr_into_memptr_cdecl.p.
run library_calls/input/input_parameter_handle_to_option_matters.p.
run library_calls/input/input_parameter_unsupported_4gl_types.p.
run library_calls/input/input_parameter_unknown_value.p.
run library_calls/input/input_parameter_many_cdecl.p.

run library_calls/read_pointer_size.p (output pointer-size).

/* windows 32-bit stdcall case */
if opsys eq "win32" and pointer-size = 4 then
do:
   run library_calls/input/input_parameter_integer_stdcall.p (input sz, input ilist).
   run library_calls/input/input_parameter_int64_stdcall.p (input sz, input ilist).
   run library_calls/input/input_parameter_decimal_stdcall.p (input dsz).
   run library_calls/input/input_parameter_char_ptr_into_memptr_stdcall.p.
   run library_calls/input/input_parameter_void_ptr_into_memptr_stdcall.p.
   run library_calls/input/input_parameter_many_stdcall.p.
end.

/* cleanup */
set-size(ptrs) = 0.
{library_calls/input/input_parameter_end.i}

run log-it (input "input_parameter end").
