{library_calls/log_hlp.i}

run log-it (input "input_output_integral_api_type_input_overflow_errors start").

{library_calls/libname.i}

def var num as int64.   

/* byte underflow */
/* Value -129 does not fit in byte DLL datatype. (13712) */
num = -129.
run input_output_uint8_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected underflow of BYTE using -129.").

/* byte overflow */
/* Value 256 does not fit in byte DLL datatype. (13712) */
num = 256.
run input_output_uint8_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected overflow of BYTE using 256.").

/* short underflow */
/* Value -32769 does not fit in short DLL datatype. (13712) */
num = -32769.
run input_output_int16_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected underflow of SHORT using -32769.").

/* short overflow */
/* Value 32768 does not fit in short DLL datatype. (13712) */
num = 32768.
run input_output_int16_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected overflow of SHORT using 32768.").

/* unsigned-short underflow */
/* Value -1 does not fit in unsigned-short DLL datatype. (13712) */
num = -1.
run input_output_uint16_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected underflow of UNSIGNED-SHORT using -1.").

/* unsigned-short overflow */
/* Value 65536 does not fit in unsigned-short DLL datatype. (13712) */
num = 65536.
run input_output_uint16_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected overflow of UNSIGNED-SHORT using 65536.").

/* long underflow */
/* Value -2147483649 does not fit in long DLL datatype. (13712) */
num = -2147483649.
run input_output_int32_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected underflow of LONG using -2147483649.").

/* long overflow */
/* Value 2147483648 does not fit in long DLL datatype. (13712) */
num = 2147483648.
run input_output_int32_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected overflow of LONG using 2147483648.").

/* unsigned-long underflow */
/* Value -1 does not fit in unsigned-long DLL datatype. (13712) */
num = -1.
run input_output_uint32_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected underflow of UNSIGNED-LONG using -1.").

/* unsigned-long overflow */
/* Value 4294967296 does not fit in unsigned-long DLL datatype. (13712) */
num = 4294967296.
run input_output_uint32_cdecl (input-output num) no-error.
if not error-status:error or not error-status:get-number(1) eq 13712 then run log-err (input "Expected overflow of UNSIGNED-LONG using 4294967296.").

procedure input_output_uint8_cdecl external "{&libname}" cdecl:
   define input-output parameter i as byte.
end.

procedure input_output_int16_cdecl external "{&libname}" cdecl:
   define input-output parameter i as short.
end.

procedure input_output_uint16_cdecl external "{&libname}" cdecl:
   define input-output parameter i as unsigned-short.
end.

procedure input_output_int32_cdecl external "{&libname}" cdecl:
   define input-output parameter i as long.
end.

procedure input_output_uint32_cdecl external "{&libname}" cdecl:
   define input-output parameter i as unsigned-long.
end.

run log-it (input "input_output_integral_api_type_input_overflow_errors end").
