{library_calls/log_hlp.i}

run log-it (input "input_output_parameter_decimal_{&callconv} error processing start").

def input parameter sz as int.

def var dnum as decimal.
def var dscratch as decimal.
def var i as int.
def var idx as int.
def var results as memptr.
def var err-flag as logical.
def var err-list as char.
def var comps as memptr.
def var d-input as dec extent.

/* We have to make it big enough to hold the (largest size apitype/smallest size apitype) */
/* double is largest apitype at 64-bits, float is the smallest apitype at 32-bits. */
/* Why? The native library does not know the way that Progress is interpreting the data type (as */
/* float or double). The native library is coded to copy floats or doubles, but when it is copying */
/* doubles into space that Progress thinks is float array space, then we need to have twice as */
/* much space allocated, so the memory passed to the native library is big enough that no invalid */
/* memory access occurs. */
def var dnum_array as decimal extent 2.

set-size(comps) = sz * 8.
run copy_dvalues (input-output comps).

extent(d-input) = sz.

/* convert the memory buffer into a decimal array, but reverse the order of the values */
do i = sz to 1 by -1:
   idx = (sz - i) + 1.
   d-input[idx] = get-double(comps, ((i - 1) * 8) + 1).
end.

set-size(comps) = 0.

set-byte-order(results) = little-endian.

/* run our tests */                  

{library_calls/input_output/input_output_float_errors.i &apiname = "input_output_double_{&callconv}" &apitype = "{&apitype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_float_errors.i &apiname = "input_output_float_{&callconv}"  &apitype = "{&apitype}" &callconv = "{&callconv}"}

procedure copy_dvalues external "{&libname}" cdecl persistent:
   define input-output parameter buf as memptr.
end.

run log-it (input "input_output_parameter_decimal_{&callconv} error processing end").
