{library_calls/log_hlp.i}

run log-it (input "input_output_parameter_integer_{&callconv} with {&apitype} start").

def input parameter sz as int.
def input parameter ilist as int64 extent.

def var {&varname} as {&vartype}.
def var i as int.
def var idx as int.                
def var results as memptr.
def var is-small as logical.
def var s-overflow as logical.
def var n-overflow as logical.
def var u-overflow as logical.
def var err-flag as logical.
def var err-list as char.

def var comps as memptr.
def var i-input as int64 extent.
def var little-input as int extent.

/* This is NASTY but we are required to hard code this size, otherwise we get this error: */
/* You cannot pass an indeterminate length array to a DLL as INPUT or receive one back as OUTPUT. (12201) */
/* In addition, we have to make it big enough to hold the ((largest size apitype/smallest size apitype) * length) */
/* int64 is largest apitype at 64-bits, byte is the smallest apitype at 8-bits and length is 69. */
/* Why? The native library does not know the way that Progress is interpreting the data type (as */
/* integer or int64). The native library is coded to copy floats or doubles, but when it is copying */
/* doubles into space that Progress thinks is float array space, then we need to have twice as */
/* much space allocated, so the memory passed to the native library is big enough that no invalid */
/* memory access occurs. */
def var inum_array as {&vartype} extent 552.

set-size(comps) = sz * 8.
run copy_ivalues (input-output comps).

extent(i-input) = sz.
extent(little-input) = sz.

/* convert the memory buffer into an int64 array, but reverse the order of the values */
do i = sz to 1 by -1:
   idx = (sz - i) + 1.
   i-input[idx] = get-int64(comps, ((i - 1) * 8) + 1).
   little-input[idx] = get-bits(get-int64(comps, ((i - 1) * 8) + 1), 1, 31).
end.
                                       
set-size(comps) = 0.

set-byte-order(results) = little-endian.

def var dbg-flag as logical.
def var i-tmp as int64.

/* only called for the apitype == int64 and vartype == integer and rettype == int32 or uint32 */
/* tests if the combination of an 0xFFFFFFFF upper doubleword combined with a lower doubleword */
/* will result in a value that cannot be assigned back to an integer */
function funky-int-mashup-is-out-of-bounds returns logical (input idx as int):
   def var all-f as int init -1.
   def var mashed as int64.
   
   /* set upper doubleword to 0xFFFFFFFF */
   put-bits(mashed, 33, 32) = get-bits(all-f, 1, 32).
   
   /* overwrite the lower doubleword with the lower 32-bits of the number that will be returned from the API */
   put-bits(mashed, 1, 32) = get-bits(ilist[idx], 1, 32).
   
   return (mashed < -2147483648 or mashed > 2147483647).
end.

/* run our tests */                  

{library_calls/input_output/input_output_int_test.i &apiname = "input_output_uint8_{&callconv}"  &rettype = "uint8"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_int_test.i &apiname = "input_output_int16_{&callconv}"  &rettype = "int16"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_int_test.i &apiname = "input_output_uint16_{&callconv}" &rettype = "uint16" &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_int_test.i &apiname = "input_output_int32_{&callconv}"  &rettype = "int32"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_int_test.i &apiname = "input_output_uint32_{&callconv}" &rettype = "uint32" &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/input_output/input_output_int_test.i &apiname = "input_output_int64_{&callconv}"  &rettype = "int64"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}

procedure copy_ivalues external "{&libname}" cdecl persistent:
   define input-output parameter buf as memptr.
end.

run log-it (input "input_output_parameter_integer_{&callconv} with {&apitype} end").
