{library_calls/log_hlp.i}
run log-it (input "load_failures start").

def var sz as int64.
def var ptr as memptr.

/* the PROCEDURE EXTERNAL library name MUST be a string literal, otherwise it is a compile error in 4GL */

&if "{&OPSYS}" eq "win32" &then
   /* omitting the DLL extension or using mismatching case names is not a problem for windows */
   /* but failures don't generate 3 errors + messages, instead only the 3rd is generated: */
   /* Could not load DLL procedure <library_name_used_in_the_procedure_external_def>. (3258) */

   run ivalues_size (output sz) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 3258     then run log-err (input "Expected load failures for 'testapi'.").
      
   run copy_ivalues (input-output ptr) no-error.
   if not error-status:error or not error-status:get-number(1) eq 3233 then run log-err (input "Should have gotten an uninitialized memptr error before load failure.").
      
   set-size(ptr) = 4096.
   run copy_ivalues (input-output ptr) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 3258     then run log-err (input "Expected load failures for 'no-such_dIrecTORy~\testapi.dll'.").
   set-size(ptr) = 0.
      
   run init_dvalues no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 3258     then run log-err (input "Expected load failures for 'c:~\toTal_garBage~\no-such_dIrecTORy~\testapi.dll'.").
   
   /* no DLL of this name exists in the search path */
   procedure ivalues_size external "some random bad name":
      define return parameter sz as long.
   end.
   
   /* bad relative path */
   procedure copy_ivalues external "no-such_dIrecTORy~\testapi.dll":
      define input-output parameter buf as memptr.
   end.
   
   /* bad absolute path */
   procedure init_dvalues external "c:~\toTal_garBage~\no-such_dIrecTORy~\testapi.dll":
   end.   
&else

   /* Could not open Dynamic Library: <library_name_used_in_the_procedure_external_def> (8013) */
   /* DLL Error : <library_name_used_in_the_procedure_external_def>: cannot open shared object file: No such file or directory (8014) */
   /* Could not load DLL procedure <library_name_used_in_the_procedure_external_def>. (3258) */

   run ivalues_size (output sz) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for 'testapi'.").
   
   run dvalues_size (output sz) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for 'libtestapi'.").
      
   run ptr_size (output sz) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for 'libteSTapi.so'.").
   
   run copy_ivalues (input-output ptr) no-error.
   if not error-status:error or not error-status:get-number(1) eq 3233 then run log-err (input "Should have gotten an uninitialized memptr error before load failure.").
      
   set-size(ptr) = 4096.
   run copy_ivalues (input-output ptr) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for 'no-such_dIrecTORy/libtestapi.so'.").
   set-size(ptr) = 0.
      
   run reset_idx no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for 'library_calls~\testapi~\libtestapi.so'.").
   
   run init_dvalues no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 8013 or
      not error-status:get-number(2) eq 8014 or
      not error-status:get-number(3) eq 3258     then run log-err (input "Expected load failures for '/toTal_garBage/no-such_dIrecTORy/libtestapi.so'.").
   
   /* no lib prefix or .so */
   procedure ivalues_size external "testapi":
      define return parameter sz as long.
   end.
   
   /* no .so */
   procedure dvalues_size external "libtestapi":
      define return parameter sz as long.
   end.
   
   /* case-sensitive mismatch */
   procedure ptr_size external "libteSTapi.so":
      def return parameter sz as long.
   end.
   
   /* bad relative path */
   procedure copy_ivalues external "no-such_dIrecTORy/libtestapi.so":
      define input-output parameter buf as memptr.
   end.
   
   /* bad relative path (wrong path seperators) */
   procedure reset_idx external "library_calls~\testapi~\libtestapi.so":
   end.
   
   /* bad absolute path */
   procedure init_dvalues external "/toTal_garBage/no-such_dIrecTORy/libtestapi.so":
   end.   
&endif

run log-it (input "load_failures end").
