{library_calls/log_hlp.i}

run log-it (input "reference_counting_tricky start").

&if "{&OPSYS}" eq "win32" &then
   def var sz as int.
   def var i as int.
   
   run log-it (input "1st call to ivalues_size for 'testapi.dll'").
   run ivalues_size (output sz).
   
   run log-it (input "2nd call to ivalues_size for 'testapi.dll'").
   run ivalues_size (output sz).
   
   run log-it (input "1st call to dvalues_size for 'testapi'").
   run dvalues_size (output sz).
   
   /* it looks like Progress 4GL only calls UnloadLibrary once for each call */
   /* to LoadLibrary AND they try to only call LoadLibrary once per DLL */
   /* the problem happens in the case where the name used is automatically */
   /* augmented by Windows (testapi will load the same thing as testapi.dll) */
   /* but the 4GL treats these are 2 different things, so it will call LoadLibrary */
   /* twice for what is the same DLL, causing Windows to increment the reference */
   /* count, leaving the DLL in memory until some 4GL code calls RELEASE EXTERNAL */
   /* for BOTH names (testapi and testapi.dll) */
   
   /* since the 4GL doesn't seem to track the actual path of the module that is */
   /* loaded AND since it seems to be quite "dumb" about the text matching for */
   /* module names (and how release external uses them), it is expected that this */
   /* same behavior would hold if a relative or absolute name was used and it */
   /* happened to load the same DLL that was loaded via some other name */
   
   /* interestingly, Progress could actually use the WIN32 GetModuleFileName() on the module */
   /* handle to get the real path and do something more intelligent, but it doesn't */
   
   do i = 1 to 10:
      run log-it (input "RELEASE EXTERNAL 'testapi.dll' # " + string(i) + ", no unload yet!").
      release external "testapi.dll".
   end.
   
   run log-it (input "RELEASE EXTERNAL 'testapi' - this one causes the unload!").
   release external "testapi".
   
   procedure ivalues_size external "testapi.dll" cdecl persistent:
      define return parameter sz as long.
   end.
   
   procedure dvalues_size external "testapi" cdecl persistent:
      define return parameter sz as long.
   end.
   
&endif

run log-it (input "reference_counting_tricky end").
