{library_calls/log_hlp.i}

run log-it (input "order_of_output_checks start").

def var i1 as int.
def var i2 as int.
def var i3 as int.
def var i4 as int.
def var errmsg as char.

/* this is the order of error checks on output, only the 1st failure found is reported (the checking process */
/* ends at that point) */

/* each parameter is processed from left to right and return is processed in whatever place it exists in the */
/* caller's definition, rather than always first or last */

i1 = 1.
i2 = -1.
i4 = 1.

run overflowInt32 (input-output i1, input-output i2, output i3, input-output i4, 1) no-error.
errmsg = error-status:get-message(1).
if not error-status:error or
   not error-status:num-messages eq 1 or
   not error-status:get-number(1) eq 15747 or
   not errmsg eq "Value 9223372036854775807 too large to fit in INTEGER. Line 0 in overflowInt32 library_calls/misc/order_of_output_checks.p. (15747)"
   then run log-err (input "The order of output operations is wrong (1). Found '" + errmsg + "'.").

i1 = 0.
i2 = -1.
i4 = 1.
run overflowInt32 (input-output i1, input-output i2, output i3, input-output i4, 1) no-error.
errmsg = error-status:get-message(1).
if not error-status:error or
   not error-status:num-messages eq 1 or
   not error-status:get-number(1) eq 15747 or
   not errmsg eq "Value -( too large to fit in INTEGER. Line 0 in overflowInt32 library_calls/misc/order_of_output_checks.p. (15747)"
   then run log-err (input "The order of output operations is wrong (2). Found '" + errmsg + "'.").

i1 = 0.
i2 = 0.
i4 = 1.
run overflowInt32 (input-output i1, input-output i2, output i3, input-output i4, -1) no-error.
errmsg = error-status:get-message(1).
if not error-status:error or
   not error-status:num-messages eq 1 or
   not error-status:get-number(1) eq 15747 or
   not errmsg eq "Value -( too large to fit in INTEGER. Line 0 in overflowInt32 library_calls/misc/order_of_output_checks.p. (15747)"
   then run log-err (input "The order of output operations for return parameter is wrong (3). Found '" + errmsg + "'.").

run log-it (input "order_of_output_checks end").

{library_calls/libname.i}

procedure overflowInt32 external "{&libname}" cdecl:
   def input-output parameter i1 as int64.
   def input-output parameter i2 as int64.
   def return       parameter i3 as int64.
   def input-output parameter i4 as int64.
   def input        parameter flag as long.
end.
