{library_calls/log_hlp.i}

run log-it (input "output_double_parameter_into_int64_is_junk start").

{library_calls/libname.i}

def var res as int64.
def var dat as dec.
def var dat2 as dec.
def var i as int.
def var idx as int.
def var sz as int.
def var ptr as memptr.
def var comps as memptr.

run dvalues_size (output sz).
run init_dvalues.

set-size(ptr) = 8.
set-size(comps) = sz * 8.

run copy_dvalues (input-output comps).

/* the data will be copied as a 64-bit binary floating point value into the int64 var, but it will */
/* not be an integer that makes sense; we need to morph it back into a double to get it to "work" */
do i = 1 to sz:
   run output_double_cdecl (output res).

   /* turn the junk into the proper number */
   put-int64(ptr, 1) = res.
   dat = get-double(ptr, 1).
   
   idx = ((i - 1) * 8) + 1.
   dat2 = get-double(comps, idx).
   
   if dat ne dat2 then run log-err (input "Unexpected output value " + string(dat) + " (index " + string(i) + "; expected " + string(dat2) + ") while reading int64 from output_double_cdecl().").
end.

set-size(ptr) = 0.

procedure output_double_cdecl external "{&libname}" cdecl:
   def output parameter dd as int64.
end.

{library_calls/output/output_parameter_end.i}

run log-it (input "output_double_parameter_into_int64_is_junk end").
