{library_calls/log_hlp.i}

run log-it (input "output_void_ptr_{&callconv} start").

{library_calls/libname.i}

def var block as memptr.
def var ptr as memptr.
def var ptr2ptr as memptr.
def var addr1 as int64.
def var addr2 as int64.
def var addr3 as int64.
def var addr4 as int64.
def var i as int.
def var b as int.
def var sz as int.
def var sz2 as int init -1.

set-size(block) = 16.
set-size(ptr) = 16.
set-size(ptr2ptr) = 8.
addr1 = get-pointer-value(block).
run set_memory_buffer (addr1, 16).
run get_memory_buffer_size (output sz2).
if sz2 ne 16 then run log-err (input "Invalid memory buffer size set (expected 16 and found sz = " + string(sz2) + ").").

do i = 1 to 16:
   put-byte(block, i) = i + 64.
end.

/* output parameters must have preallocated buffers whose contents will be changed */
addr2 = get-pointer-value(ptr).
run output_void_ptr_{&callconv} (output ptr).
addr3 = get-pointer-value(ptr).

if addr2 ne addr3 then run log-err (input "Expected address " + string(addr2) + " and got " + string(addr3) + ".").

do i = 1 to 16:
   b = get-byte(ptr, i).
   if b ne (i + 64) then run log-err (input "Expected byte value " + string(i + 64) + " and instead found " + string(b)).
end.

run ptr_size (output sz).
run output_void_ptr_ptr_{&callconv} (output ptr2ptr).

if sz = 4 then
   addr4 = get-long(ptr2ptr, 1).
else
   addr4 = get-int64(ptr2ptr, 1).

if addr1 ne addr4 then run log-err (input "Expected (2) address " + string(addr1) + " and got " + string(addr4) + ".").

set-size(block) = 0.
set-size(ptr) = 0.
set-size(ptr2ptr) = 0.

procedure set_memory_buffer external "{&libname}" cdecl persistent:
   def input parameter ptr as int64.
   def input parameter sz as long.
end.

procedure get_memory_buffer_size external "{&libname}" cdecl persistent:
   def return parameter sz as long.
end.

procedure ptr_size external "{&libname}" cdecl persistent:
   def return parameter sz as long.
end.

procedure output_void_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def output parameter ptr as memptr.
end.

procedure output_void_ptr_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def output parameter ptr as memptr.
end.

run log-it (input "output_void_ptr_{&callconv} end").
