{library_calls/log_hlp.i}

run log-it (input "output_parameter_integer_{&callconv} with {&apitype} start").

def input parameter sz as int.
def input parameter ilist as int64 extent.

def var {&varname} as {&vartype}.
def var i as int.
def var idx as int.                
def var results as memptr.
def var s-overflow as logical.
def var n-overflow as logical.
def var u-overflow as logical.
def var err-flag as logical.
def var err-list as char.

/* This is NASTY but we are required to hard code this size, otherwise we get this error: */
/* You cannot pass an indeterminate length array to a DLL as INPUT or receive one back as OUTPUT. (12201) */
/* In addition, we have to make it big enough to hold the ((largest size apitype/smallest size apitype) * length) */
/* int64 is largest apitype at 64-bits, byte is the smallest apitype at 8-bits and length is 69. */
/* Why? The native library does not know the way that Progress is interpreting the data type (as */
/* integer or int64). The native library is coded to copy floats or doubles, but when it is copying */
/* doubles into space that Progress thinks is float array space, then we need to have twice as */
/* much space allocated, so the memory passed to the native library is big enough that no invalid */
/* memory access occurs. */
def var inum_array as {&vartype} extent 552.
                                       
set-byte-order(results) = little-endian.

/* run our tests */                  

{library_calls/output/output_int_test.i &apiname = "output_uint8_{&callconv}"  &rettype = "uint8"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/output/output_int_test.i &apiname = "output_int16_{&callconv}"  &rettype = "int16"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/output/output_int_test.i &apiname = "output_uint16_{&callconv}" &rettype = "uint16" &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/output/output_int_test.i &apiname = "output_int32_{&callconv}"  &rettype = "int32"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/output/output_int_test.i &apiname = "output_uint32_{&callconv}" &rettype = "uint32" &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}
{library_calls/output/output_int_test.i &apiname = "output_int64_{&callconv}"  &rettype = "int64"  &apitype = "{&apitype}" &varname = "{&varname}" &vartype = "{&vartype}" &callconv = "{&callconv}"}

run log-it (input "output_parameter_integer_{&callconv} with {&apitype} end").
