{library_calls/log_hlp.i}

run log-it (input "output_parameter_unknown_value start").

{library_calls/libname.i}

def var num as int init ?.
def var num64 as int init ?.
def var dnum as dec init ?.
def var txt as char init ?.
def var ltxt as longchar init ?.
def var ptr as memptr.
def var uninitialized-ptr as memptr.

def var blk as memptr.
def var addr as int64.

set-size(blk) = 16.
addr = get-pointer-value(blk).
run set_memory_buffer (addr, 16).

/* integer/int64 cases just silently return with no changes and no error */

run output_uint8_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'byte into output integer' test but found " + string(num)).

run reset_idx.

run output_int16_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'short into output integer' test but found " + string(num)).

run reset_idx.

run output_uint16_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'unsigned-short into output integer' test but found " + string(num)).

run reset_idx.

run output_int32_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'long into output integer' test but found " + string(num)).
   
run reset_idx.

run output_uint32_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'unsigned-long into output integer' test but found " + string(num)).
   
run reset_idx.

run output_int64_cdecl (output num).
if num ne ? then run log-err (input "Expected ? from 'int64 into output integer' test but found " + string(num)).
   
run reset_idx.

run output_uint8_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'byte into output int64' test but found " + string(num64)).

run reset_idx.

run output_int16_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'short into output int64' test but found " + string(num64)).

run reset_idx.

run output_uint16_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'unsigned-short into output int64' test but found " + string(num64)).

run reset_idx.

run output_int32_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'long into output int64' test but found " + string(num64)).
   
run reset_idx.

run output_uint32_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'unsigned-long into output int64' test but found " + string(num64)).
   
run reset_idx.

run output_int64_cdecl (output num64).
if num64 ne ? then run log-err (input "Expected ? from 'int64 into output int64' test but found " + string(num64)).
   
run reset_idx.

/* decimal cases act the same way as decimal return parms */

run output_float_cdecl (output dnum).
if dnum ne 0 then run log-err (input "Expected 0 from 'float into output decimal' test but found " + string(dnum)).
   
run reset_idx.

run output_double_cdecl (output dnum).
if dnum ne 0 then run log-err (input "Expected 0 from 'double into output decimal' test but found " + string(dnum)).
   
run reset_idx.

/* Unknown value is not good for some pointer-based types. */

/* This generates an ERROR, even if NO-ERROR is present! */
/* A CHARACTER or LONGCHAR variable passed as an OUTPUT parameter to a DLL cannot be the Unknown value or be uninitialised. (12450) */
do on error undo, leave:
   run output_char_ptr_cdecl (output txt) no-error.
   run log-err (input "This never should appear because the 4GL makes no sense.").
end.
if not error-status:error or not error-status:get-number(1) eq 12450 then run log-err (input "Expected an error passing an unknown character var for an output parameter (got '" + txt + "').").

/* This just silently returns with no changes and no error raised. */
run output_char_ptr_cdecl (output ltxt) no-error.
if not error-status:error or not error-status:get-number(1) eq 12450 then run log-err (input "Expected an error passing an unknown longchar var for an output parameter (got '" + string(ltxt) + "').").

txt = "".

/* This just silently returns with no changes and no error raised. */
run output_char_ptr_cdecl (output txt) no-error.
if txt ne "" then run log-err (input "Expected a silent return from passing an empty character var for an output parameter (got '" + txt + "').").

ltxt = "".
   
/* This just silently returns with no changes and no error raised. */
run output_char_ptr_cdecl (output ltxt) no-error.
if ltxt ne "" then run log-err (input "Expected a silent return from passing an empty longchar var for an output parameter (got '" + string(ltxt) + "').").

/* different from return parms: this generates an error instead of abending the process */
/* DLL procedure output_void_ptr_cdecl /home/someone/p93898_output_parameter_unknown_value.ped using an uninitialised MEMPTR. (3233) */
ptr = ?.
run output_void_ptr_cdecl (output ptr) no-error.
if not error-status:error or not error-status:get-number(1) eq 3233 then run log-err (input "Expected an error passing an unknown memptr var for an output parameter (got '" + string(get-pointer-value(ptr)) + "').").

/* different from return parms: this generates an error instead of actually working */
/* DLL procedure output_void_ptr_cdecl /home/someone/p93898_output_parameter_unknown_value.ped using an uninitialised MEMPTR. (3233) */
run output_void_ptr_cdecl (output uninitialized-ptr) no-error.
if not error-status:error or not error-status:get-number(1) eq 3233 then run log-err (input "Expected an error passing an uninitialized memptr var for an output parameter (got '" + string(get-pointer-value(uninitialized-ptr)) + "').").

/* different from return parms: this generates an error instead of abending the process */
/* DLL procedure output_void_ptr_cdecl /home/someone/p93898_output_parameter_unknown_value.ped using an uninitialised MEMPTR. (3233) */
set-size(uninitialized-ptr) = 0.
run output_void_ptr_cdecl (output uninitialized-ptr) no-error.
if not error-status:error or not error-status:get-number(1) eq 3233 then run log-err (input "Expected an error passing a 0 size memptr var for an output parameter (got '" + string(get-pointer-value(uninitialized-ptr)) + "').").

set-size(blk) = 0.

{library_calls/output/output_parameter_end.i}

procedure set_memory_buffer external "{&libname}" cdecl persistent:
   def input parameter ptr as int64.
   def input parameter sz as long.
end.

procedure reset_idx external "{&libname}" cdecl:
end.

procedure output_uint8_cdecl external "{&libname}" cdecl:
   def output parameter r as byte.
end.

procedure output_int16_cdecl external "{&libname}" cdecl:
   def output parameter r as short.
end.

procedure output_uint16_cdecl external "{&libname}" cdecl:
   def output parameter r as unsigned-short.
end.

procedure output_int32_cdecl external "{&libname}" cdecl:
   def output parameter r as long.
end.

procedure output_uint32_cdecl external "{&libname}" cdecl:
   def output parameter r as unsigned-long.
end.

procedure output_int64_cdecl external "{&libname}" cdecl:
   def output parameter r as int64.
end.

procedure output_float_cdecl external "{&libname}" cdecl:
   def output parameter r as float.
end.

procedure output_double_cdecl external "{&libname}" cdecl:
   def output parameter r as double.
end.

procedure output_char_ptr_cdecl external "{&libname}" cdecl:
   def output parameter r as char.
end.

procedure output_void_ptr_cdecl external "{&libname}" cdecl:
   def output parameter r as memptr.
end.

run log-it (input "output_parameter_unknown_value end").
