{library_calls/log_hlp.i}

run log-it (input "return_double_paramter_into_int64_is_junk start").

{library_calls/libname.i}

def var res as int64.
def var i as int.
def var sz as int.
def var pointer-size as int.

run dvalues_size (output sz).
run init_dvalues.
run library_calls/read_pointer_size.p (output pointer-size).


/* on 32-bit systems, the EAX register seems to be used to hold the subscripting */
/* index used inside the library, so when we read the "return value", it reads the */
/* "trash" that was left there instead of getting the actual return data which is */
/* passed back via the floating point registers */

/* on 64-bit systems, the generated code uses RAX for return value processing (it */
/* actually returns the double value in xmm0 but rax is used for scratch storage */
/* after we have already cleared it with the CLEAR_RETURN_REGISTER macro; the */
/* key point: the return value is such junk that it cannot be checked */

do i = 1 to sz:
   run return_double_cdecl (output res).
   if pointer-size = 4 and res ne 0 and res ne i then run log-err (input "Unexpected return value " + string(res) + " (index " + string(i) + ") while reading int64 from return_double_cdecl().").
end.

procedure return_double_cdecl external "{&libname}" cdecl:
   def return parameter dd as int64.
end.

{library_calls/return/return_parameter_end.i}

run log-it (input "return_double_paramter_into_int64_is_junk end").
