#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>

typedef int (__cdecl *ivalues_size)();

int main(int argc, char** argv)
{
  HMODULE hmod = LoadLibrary(TEXT("testapi.dll"));
  
  if (hmod == NULL)
  {
     fprintf(stderr, "Error loading \"testapi.dll\".\n");
     return EXIT_FAILURE;
  }
  
  printf("Library is loaded at address %p.\n", hmod);
  
  LPTSTR pfname = (LPTSTR) malloc(1024 * sizeof(TCHAR));
  int rc = GetModuleFileName(hmod, pfname, 1024);
   
  printf("Full pathname is %s.\n", pfname);
  
  ivalues_size ivs = (ivalues_size) GetProcAddress(hmod, "ivalues_size");
  
  if (ivs == NULL)
  {
     fprintf(stderr, "Error locating \"ivalues_size\" function.\n");
     return EXIT_FAILURE;
  }

  printf("ivalues_size function is located at address %p.\n", ivs);
  printf("The ivalues size is %d\n", ivs());

  FreeLibrary(hmod);

  return EXIT_SUCCESS;
}

void windowsLogger(char* txt)
{
   MessageBox(NULL, txt, "before", 0);
   HANDLE hfile = CreateFile(LOGNAME, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
   
   if (hfile != NULL)
   {
      DWORD written = 0;
      
      WriteFile(hfile, txt, strlen(txt), &written, NULL);
      MessageBox(NULL, txt, "middle", 0);
      CloseHandle(hfile);
   }
   
   MessageBox(NULL, txt, "after", 0);
}
