
#include "helper.h"
#include <string.h>
#include <stdio.h>

extern int64_t ivalues[];
extern int i_idx;
extern int64_t mask;
extern int i_len;
extern double dvalues[];
extern int d_idx;
extern int d_len;
extern char* text;
extern char* other;
extern int o_len;
extern int64_t num64;

#define COPYIFUNC(typ, fname, maskval)  DLL_HIDE void fname(typ * val)\
{\
   mask = maskval;\
   int64_t num = (ivalues[i_idx++] & mask);\
\
   if (i_idx >= i_len)\
      i_idx = 0;\
\
   *val = num;\
\
   flog(#fname "() - writing %" PRId64 " with mask 0x%016X\n", num, mask);\
}

#define COPYDFUNC(typ, fname)  DLL_HIDE void fname(typ * val)\
{\
   typ num = dvalues[d_idx++];\
\
   if (d_idx >= d_len)\
      d_idx = 0;\
\
   *val = num;\
\
   flog(#fname "() - writing %g\n", num);\
}

#define OUTFUNC(typ, cconv, fname, gname)  DLL_EXPORT void cconv fname(typ * val) { gname(val); }

#define OUTIARRAY(typ, cconv, fname, maskval)  DLL_EXPORT void cconv fname(typ * val)\
{\
   mask = maskval;\
\
   for (int i = 0; i < i_len; i++)\
      val[i] = (ivalues[i] & mask);\
\
   flog(#fname "() with mask 0x%016X\n", mask);\
}

#define OUTDARRAY(typ, cconv, fname)  DLL_EXPORT void cconv fname(typ * val)\
{\
   for (int i = 0; i < d_len; i++)\
      val[i] = dvalues[i];\
\
   flog(#fname "()\n");\
}

// CDECL functions
DLL_EXPORT void CDECL output_char_ptr_cdecl(char* ptr) { strcpy(ptr, text); flog("output_char_ptr_cdecl()\n"); }
DLL_EXPORT void CDECL output_char_ptr_cdecl_array(char* ptr[], int len)
{
   int n = 0;
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         sprintf(ptr[i], "%i", i);
         n++;
      }
   }
   
   flog("output_char_ptr_cdecl_array() - %i elements processed\n", n);
}

DLL_EXPORT void CDECL output_void_ptr_cdecl(void* ptr) { memcpy(ptr, other, o_len); flog("output_void_ptr_cdecl()\n"); }
DLL_EXPORT void CDECL output_void_ptr_cdecl_array(void* ptr[], int len)
{
   int n = 0;
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         memcpy(ptr[i], other, o_len);
         n++;
      }
   }
   
   flog("output_void_ptr_cdecl_array() - %i elements processed\n", n);
}

DLL_EXPORT void CDECL output_char_ptr_ptr_cdecl(char** ptrptr) { *ptrptr = text; flog("output_char_ptr_ptr_cdecl()\n"); }
DLL_EXPORT void CDECL output_void_ptr_ptr_cdecl(void** ptrptr) { *ptrptr = (void*) other; flog("output_void_ptr_ptr_cdecl()\n"); }
DLL_EXPORT void CDECL output_int64_ptr_cdecl(int64_t* ptr) { *ptr = num64; flog("output_int64_ptr_cdecl()\n"); }

DLL_EXPORT int64_t CDECL output_order_of_ops_cdecl(int64_t* i1, int64_t* i2, int64_t* i3)
{
   flog("output_order_of_ops_cdecl()\n");
   *i1 = 0x8FFFFFFFFFFFFF01; *i2 = 0x8FFFFFFFFFFFFF02; *i3 = 0x8FFFFFFFFFFFFF03;
   return 0x8FFFFFFFFFFFFF04;
}

DLL_EXPORT void CDECL output_int32_8_parm_cdecl(int32_t* i1, int32_t* i2, int32_t* i3, int32_t* i4, int32_t* i5, int32_t* i6, int32_t* i7, int32_t* i8)
{
   flog("output_int32_8_parm_cdecl()\n");
   *i1 = 0x8FFFFF01; *i2 = 0x8FFFFF02; *i3 = 0x8FFFFF03; *i4 = 0x8FFFFF04; *i5 = 0x8FFFFF05; *i6 = 0x8FFFFF06; *i7 = 0x8FFFFF07; *i8 = 0x8FFFFF08;
}

DLL_EXPORT void CDECL output_int64_8_parm_cdecl(int64_t* i1, int64_t* i2, int64_t* i3, int64_t* i4, int64_t* i5, int64_t* i6, int64_t* i7, int64_t* i8)
{
   flog("output_int64_8_parm_cdecl()\n");
   *i1 = 0x8FFFFFFFFFFFFF01; *i2 = 0x8FFFFFFFFFFFFF02; *i3 = 0x8FFFFFFFFFFFFF03; *i4 = 0x8FFFFFFFFFFFFF04; *i5 = 0x8FFFFFFFFFFFFF05; *i6 = 0x8FFFFFFFFFFFFF06; *i7 = 0x8FFFFFFFFFFFFF07; *i8 = 0x8FFFFFFFFFFFFF08;
}

DLL_EXPORT void CDECL output_double_8_parm_cdecl(double* d1, double* d2, double* d3, double* d4, double* d5, double* d6, double* d7, double* d8)
{
   flog("output_double_8_parm_cdecl()\n");
   *d1 = 100; *d2 = 99; *d3 = 98; *d4 = 97; *d5 = 96; *d6 = 95; *d7 = 94; *d8 = 93;
}

DLL_EXPORT void CDECL output_float_8_parm_cdecl(float* f1, float* f2, float* f3, float* f4, float* f5, float* f6, float* f7, float* f8)
{
   flog("output_float_8_parm_cdecl()\n");
   *f1 = 100; *f2 = 99; *f3 = 98; *f4 = 97; *f5 = 96; *f6 = 95; *f7 = 94; *f8 = 93;
}

DLL_EXPORT void CDECL output_char_ptr_8_parm_cdecl(char* c1, char* c2, char* c3, char* c4, char* c5, char* c6, char* c7, char* c8)
{
   flog("output_char_ptr_8_parm_cdecl()\n");
   strcpy(c1, "0"); strcpy(c2, "1"); strcpy(c3, "2"); strcpy(c4, "3"); strcpy(c5, "4"); strcpy(c6, "5"); strcpy(c7, "6"); strcpy(c8, "7");
}

COPYIFUNC(uint8_t, copy_uint8_value, 0x00000000000000FFLL)
OUTFUNC(uint8_t, CDECL, output_uint8_cdecl, copy_uint8_value)
OUTIARRAY(uint8_t, CDECL, output_uint8_cdecl_array, 0x00000000000000FFLL)

COPYIFUNC(int16_t, copy_int16_value, 0x000000000000FFFFLL)                
OUTFUNC(int16_t, CDECL, output_int16_cdecl, copy_int16_value)
OUTIARRAY(int16_t, CDECL, output_int16_cdecl_array, 0x000000000000FFFFLL)

COPYIFUNC(uint16_t, copy_uint16_value, 0x000000000000FFFFLL)
OUTFUNC(uint16_t, CDECL, output_uint16_cdecl, copy_uint16_value)
OUTIARRAY(uint16_t, CDECL, output_uint16_cdecl_array, 0x000000000000FFFFLL)

COPYIFUNC(int32_t, copy_int32_value, 0x00000000FFFFFFFFLL)
OUTFUNC(int32_t, CDECL, output_int32_cdecl, copy_int32_value)
OUTIARRAY(int32_t, CDECL, output_int32_cdecl_array, 0x00000000FFFFFFFFLL)

COPYIFUNC(uint32_t, copy_uint32_value, 0x00000000FFFFFFFFLL)
OUTFUNC(uint32_t, CDECL, output_uint32_cdecl, copy_uint32_value)
OUTIARRAY(uint32_t, CDECL, output_uint32_cdecl_array, 0x00000000FFFFFFFFLL)

COPYIFUNC(int64_t, copy_int64_value, 0xFFFFFFFFFFFFFFFFLL)
OUTFUNC(int64_t, CDECL, output_int64_cdecl, copy_int64_value)
OUTIARRAY(int64_t, CDECL, output_int64_cdecl_array, 0xFFFFFFFFFFFFFFFFLL)

COPYDFUNC(float, copy_float_value)
OUTFUNC(float, CDECL, output_float_cdecl, copy_float_value)
OUTDARRAY(float, CDECL, output_float_cdecl_array)

COPYDFUNC(double, copy_double_value)
OUTFUNC(double, CDECL, output_double_cdecl, copy_double_value)
OUTDARRAY(double, CDECL, output_double_cdecl_array)

// STDCALL functions (only emit on Windows 32-bit)
#ifdef WINDOWS32
OUTFUNC(uint8_t, STDCALL, output_uint8_stdcall, copy_uint8_value)
OUTIARRAY(uint8_t, STDCALL, output_uint8_stdcall_array, 0x00000000000000FFLL)

OUTFUNC(int16_t, STDCALL, output_int16_stdcall, copy_int16_value)
OUTIARRAY(int16_t, STDCALL, output_int16_stdcall_array, 0x000000000000FFFFLL)

OUTFUNC(uint16_t, STDCALL, output_uint16_stdcall, copy_uint16_value)
OUTIARRAY(uint16_t, STDCALL, output_uint16_stdcall_array, 0x000000000000FFFFLL)

OUTFUNC(int32_t, STDCALL, output_int32_stdcall, copy_int32_value)
OUTIARRAY(int32_t, STDCALL, output_int32_stdcall_array, 0x00000000FFFFFFFFLL)

OUTFUNC(uint32_t, STDCALL, output_uint32_stdcall, copy_uint32_value)
OUTIARRAY(uint32_t, STDCALL, output_uint32_stdcall_array, 0x00000000FFFFFFFFLL)

OUTFUNC(int64_t, STDCALL, output_int64_stdcall, copy_int64_value)
OUTIARRAY(int64_t, STDCALL, output_int64_stdcall_array, 0xFFFFFFFFFFFFFFFFLL)

OUTFUNC(float, STDCALL, output_float_stdcall, copy_float_value)
OUTDARRAY(float, STDCALL, output_float_stdcall_array)

OUTFUNC(double, STDCALL, output_double_stdcall, copy_double_value)
OUTDARRAY(double, STDCALL, output_double_stdcall_array)

DLL_EXPORT void STDCALL output_char_ptr_stdcall(char* ptr) { strcpy(ptr, text); flog("output_char_ptr_stdcall()\n"); }
DLL_EXPORT void STDCALL output_char_ptr_stdcall_array(char* ptr[], int len)
{
   int n = 0;
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         sprintf(ptr[i], "%i", i);
         n++;
      }
   }
   
   flog("output_char_ptr_stdcall_array() - %i elements processed\n", n);
}

DLL_EXPORT void STDCALL output_void_ptr_stdcall(void* ptr) { memcpy(ptr, other, o_len); flog("output_void_ptr_stdcall()\n"); }
DLL_EXPORT void STDCALL output_char_ptr_ptr_stdcall(char** ptrptr) { *ptrptr = text; flog("output_char_ptr_ptr_stdcall()\n"); }
DLL_EXPORT void STDCALL output_void_ptr_ptr_stdcall(void** ptrptr) { *ptrptr = (void*) other; flog("output_void_ptr_ptr_stdcall()\n"); }

DLL_EXPORT void STDCALL output_int32_8_parm_stdcall(int32_t* i1, int32_t* i2, int32_t* i3, int32_t* i4, int32_t* i5, int32_t* i6, int32_t* i7, int32_t* i8)
{
   flog("output_int32_8_parm_stdcall()\n");
   *i1 = 0x8FFFFF01; *i2 = 0x8FFFFF02; *i3 = 0x8FFFFF03; *i4 = 0x8FFFFF04; *i5 = 0x8FFFFF05; *i6 = 0x8FFFFF06; *i7 = 0x8FFFFF07; *i8 = 0x8FFFFF08;
}

DLL_EXPORT void STDCALL output_int64_8_parm_stdcall(int64_t* i1, int64_t* i2, int64_t* i3, int64_t* i4, int64_t* i5, int64_t* i6, int64_t* i7, int64_t* i8)
{
   flog("output_int64_8_parm_stdcall()\n");
   *i1 = 0x8FFFFFFFFFFFFF01; *i2 = 0x8FFFFFFFFFFFFF02; *i3 = 0x8FFFFFFFFFFFFF03; *i4 = 0x8FFFFFFFFFFFFF04; *i5 = 0x8FFFFFFFFFFFFF05; *i6 = 0x8FFFFFFFFFFFFF06; *i7 = 0x8FFFFFFFFFFFFF07; *i8 = 0x8FFFFFFFFFFFFF08;
}

DLL_EXPORT void STDCALL output_double_8_parm_stdcall(double* d1, double* d2, double* d3, double* d4, double* d5, double* d6, double* d7, double* d8)
{
   flog("output_double_8_parm_stdcall()\n");
   *d1 = 100; *d2 = 99; *d3 = 98; *d4 = 97; *d5 = 96; *d6 = 95; *d7 = 94; *d8 = 93;
}

DLL_EXPORT void STDCALL output_float_8_parm_stdcall(float* f1, float* f2, float* f3, float* f4, float* f5, float* f6, float* f7, float* f8)
{
   flog("output_float_8_parm_stdcall()\n");
   *f1 = 100; *f2 = 99; *f3 = 98; *f4 = 97; *f5 = 96; *f6 = 95; *f7 = 94; *f8 = 93;
}

DLL_EXPORT void STDCALL output_char_ptr_8_parm_stdcall(char* c1, char* c2, char* c3, char* c4, char* c5, char* c6, char* c7, char* c8)
{
   flog("output_char_ptr_8_parm_stdcall()\n");
   strcpy(c1, "0"); strcpy(c2, "1"); strcpy(c3, "2"); strcpy(c4, "3"); strcpy(c5, "4"); strcpy(c6, "5"); strcpy(c7, "6"); strcpy(c8, "7");
}
#endif
